Index: roard/streams.c
===================================================================
--- roard/streams.c	(revision 6052)
+++ roard/streams.c	(revision 0)
@@ -940,863 +120,8 @@
 }
 
-int streams_get_clientobj (int id, struct roar_stream        ** stream) {
- _CHECK_SID(id);
-
- *stream = ROAR_STREAM(g_streams[id]);
-
- return 0;
-}
-
-int streams_set_socktype (int id, int socktype) {
- _CHECK_SID(id);
-
- g_streams[id]->socktype = socktype;
-
- return 0;
-}
-
-int streams_get_socktype (int id) {
- _CHECK_SID(id);
-
- return g_streams[id]->socktype;
-}
-
-int streams_is_ready     (int id) {
- _CHECK_SID(id);
-
- return g_streams[id]->ready;
-}
-
-int streams_is_new       (int id) {
- _CHECK_SID(id);
-
- return g_streams[id]->ready;
-}
-
-int streams_set_primary (int id, int prim) {
- _CHECK_SID(id);
-
- g_streams[id]->primary = prim;
-
- return 0;
-}
-
-int streams_mark_primary (int id) {
- return streams_set_primary(id, 1);
-}
-
-int streams_set_sync     (int id, int sync) {
- int fh = streams_get_fh(id);
-
- ROAR_DBG("streams_set_sync(id=%i, sync=%i) = ?", id, sync);
-
- _CHECK_SID(id);
-
- if ( fh > -1 ) {
-  if ( roar_socket_nonblock(fh, sync ? ROAR_SOCKET_BLOCK : ROAR_SOCKET_NONBLOCK) == -1 )
-   return -1;
-
-#ifdef ROAR_FDATASYNC
-  ROAR_FDATASYNC(fh);
-#endif
-
-  return 0;
- } else {
-  return roar_vio_nonblock(&(g_streams[id]->vio), sync);
- }
-}
-
-int streams_set_mmap (int id, int reset) {
- int use = !reset;
-
- _CHECK_SID(id);
-
- return roar_vio_ctl(&(g_streams[id]->vio), ROAR_VIO_CTL_SET_UMMAP, &use);
-}
-
-int streams_set_single_sink(int id, int reset) {
- struct roar_stream_server * self_ss, * ss;
- struct roar_stream                   *  s;
- int mixer;
- size_t count = 0;
- int i;
- int ssdir;
-
- /* FIXME: This code only uses one refc for the mixer shared with the inputs.
-  *        If the flag is unset on the mixer but got set by the sources the counter
-  *        may/will become corrupted.
-  */
-
- _CHECK_SID(id);
-
- self_ss = g_streams[id];
-
- mixer = self_ss->mixer_stream;
-
- ROAR_DBG("streams_set_single_sink(id=%i, reset=%i): mixer=%i", id, reset, mixer);
-
- if ( !reset && id != mixer )
-  if ( self_ss->flags & ROAR_FLAG_SINGLESINK )
-   return 0;
-
- if ( id == mixer ) {
-  if ( reset ) {
-   if ( self_ss->single_sink_self_c ) {
-    ROAR_DBG("streams_set_single_sink(id=%i, reset=%i): mixer=%i", id, reset, mixer);
-    self_ss->single_sink_self_c--;
-    self_ss->single_sink_c--;
-    if ( self_ss->single_sink_c == 0 ) {
-     ROAR_DBG("streams_set_single_sink(id=%i, reset=%i): mixer=%i", id, reset, mixer);
-     self_ss->flags |= ROAR_FLAG_SINGLESINK;
-     self_ss->flags -= ROAR_FLAG_SINGLESINK;
-    }
-    return 0;
-   } else {
-    return -1;
-   }
-  } else {
-   if ( self_ss->single_sink_c ) {
-    self_ss->single_sink_self_c++;
-    self_ss->single_sink_c++;
-    return 0;
-   }
-  }
- } else if ( reset ) {
-  ROAR_DBG("streams_set_single_sink(id=%i, reset=%i): mixer=%i", id, reset, mixer);
-
-  if ( (ss = g_streams[mixer]) == NULL )
-   return -1;
-
-  if ( ss->single_sink_c == 0 )
-   return -1;
-  ss->single_sink_c--;
-
-  if ( ss->single_sink_c == 0 ) {
-    self_ss->flags |= ROAR_FLAG_SINGLESINK;
-    self_ss->flags -= ROAR_FLAG_SINGLESINK;
-         ss->flags |= ROAR_FLAG_SINGLESINK;
-         ss->flags -= ROAR_FLAG_SINGLESINK;
-  }
-
-  return 0;
- }
-
-
-
- for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-  if ( (s = ROAR_STREAM((ss = g_streams[i]))) != NULL ) {
-   if ( s->dir == ROAR_DIR_THRU )
-    if ( s->pos_rel_id == id || s->pos_rel_id == mixer || g_streams[s->pos_rel_id]->mixer_stream == mixer )
-     return -1;
-
-   if ( ss->mixer_stream != mixer )
-    continue;
-
-   ssdir = streams_get_ssdir(i);
-
-   if ( ssdir & STREAM_DIR_OUT )
-    count++;
-  }
- }
-
- if ( count > 1 )
-  return -1;
-
- ss = g_streams[mixer];
-
- if ( id == mixer )
-  ss->single_sink_self_c++;
-
- ss->single_sink_c++;
-
- self_ss->flags |= ROAR_FLAG_SINGLESINK;
-      ss->flags |= ROAR_FLAG_SINGLESINK;
-
- return 0;
-}
-
-int streams_set_flag     (int id, uint32_t flag) {
- int parent;
- int tmp;
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- _CHECK_SID(id);
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_IMMUTABLE )
-  flag |= ROAR_FLAG_PRIMARY;
-
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- // check if flags we are going to change are protected:
- if ( g_streams[id]->flags_protection & flag )
-  return -1;
-
- flag |= g_streams[id]->flags;
- flag -= g_streams[id]->flags;
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_MMAP ) {
-  if ( streams_set_mmap(id, 0) == -1 ) {
-   flag -= ROAR_FLAG_MMAP;
-   return -1;
-  }
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_PRIMARY ) {
-  streams_set_primary(id, 1);
-  flag -= ROAR_FLAG_PRIMARY;
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_SINGLESINK ) {
-  if ( streams_set_single_sink(id, 0) == -1 ) {
-   return -1;
-  }
-  flag -= ROAR_FLAG_SINGLESINK;
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_VIRTUAL ) {
-  if ( (parent = ROAR_STREAM(g_streams[id])->pos_rel_id) == -1 )
-   return -1;
-
-  if ( streams_ctl(parent, ROAR_CODECFILTER_CTL_VIRTUAL_NEW|ROAR_STREAM_CTL_TYPE_INT, &id) == -1 ) {
-//   flag -= ROAR_FLAG_VIRTUAL;
-   return -1;
-  }
-
-  if ( client_stream_move(streams_get_client(parent), id) == -1 ) {
-   return -1;
-  }
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_SYNC ) {
-  ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-  switch (ROAR_STREAM(g_streams[id])->dir) {
-   // for this stream types the flag is used in the subsystem:
-   case ROAR_DIR_BRIDGE:
-   case ROAR_DIR_MIDI_OUT:
-    break;
-
-   // normal behavor (vio blocking):
-   default:
-     ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-     // the fh is updated as soon as the fh get ready in case the default ask to set sync
-     if ( g_streams[id]->ready || (!g_streams[id]->ready && !(g_config->streams[ROAR_STREAM(g_streams[id])->dir].flags & ROAR_FLAG_SYNC)) ) {
-      ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-      if ( streams_set_sync(id, 1) == -1 ) {
-       ROAR_WARN("streams_set_flag(id=%i, flag=0x%.8X): Can not set SYNC flag.", id, flag);
-       flag -= ROAR_FLAG_SYNC;
-      }
-     }
-    break;
-  }
-  ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
-  if ( flag & ROAR_FLAG_SYNC ) {
-   g_streams[id]->flags |= ROAR_FLAG_SYNC;
-   streams_change_sync_num(id, +1);
-  }
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_HWMIXER ) { // currently not supported -> ignored
-  g_streams[id]->flags |= flag;
-  if ( streams_set_mixer(id) == -1 ) {
-   g_streams[id]->flags -= flag;
-   return -1;
-  }
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( flag & ROAR_FLAG_RECSOURCE ) {
-  if ( streams_recsource_id != -1 ) {
-   if ( streams_reset_flag(streams_recsource_id, ROAR_FLAG_RECSOURCE) == -1 )
-    return -1;
-  }
-
-  if ( g_streams[id]->ready ) {
-   tmp = 1;
-   if ( stream_vio_ctl(id, ROAR_VIO_CTL_SET_RECORD, &tmp) == -1 )
-    return -1;
-  }
-
-  streams_recsource_id = id;
- }
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- g_streams[id]->flags |= flag;
-
-#ifdef ROAR_SUPPORT_META
- if ( flag & ROAR_FLAG_META )
-  stream_meta_finalize(id);
-#endif
-
- ROAR_DBG("streams_set_flag(id=%i, flag=0x%.8X) = 0", id, flag);
-
- return 0;
-}
-
-int streams_set_rawflag  (int id, uint32_t flag) {
- _CHECK_SID(id);
-
- g_streams[id]->flags |= flag;
-
- if ( flag & ROAR_FLAG_SYNC )
-  streams_change_sync_num(id, +1);
-
- return 0;
-}
-
-int streams_reset_flag   (int id, uint32_t flag) {
- int tmp;
-
- ROAR_DBG("streams_reset_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- _CHECK_SID(id);
-
- // check if flags we are going to change are protected:
- if ( g_streams[id]->flags_protection & flag )
-  return -1;
-
- if ( g_streams[id]->flags & ROAR_FLAG_IMMUTABLE ) {
-  flag |= ROAR_FLAG_PRIMARY;
-  flag -= ROAR_FLAG_PRIMARY;
- }
-
- flag &= g_streams[id]->flags;
-
- ROAR_DBG("streams_reset_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
- if ( (flag & ROAR_FLAG_RECSOURCE) && streams_recsource_id == id ) {
-  if ( g_streams[id]->ready ) {
-   tmp = 0;
-   if ( stream_vio_ctl(id, ROAR_VIO_CTL_SET_RECORD, &tmp) == -1 ) {
-    if ( alive ) { // do not warn if we are shutting down anyway.
-     ROAR_WARN("streams_reset_flag(id=%i, flag=0x%.8X): Driver refused to reset record flag.", id, flag);
-    }
-    ROAR_DBG("streams_reset_flag(id=%i, flag=0x%.8X) = -1", id, flag);
-    return -1;
-   }
-  }
-
-  streams_recsource_id = -1;
- }
-
- ROAR_DBG("streams_reset_flag(id=%i, flag=0x%.8X) = ?", id, flag);
-
-
- if ( flag & ROAR_FLAG_MMAP ) {
-  if ( streams_set_mmap(id, 1) == -1 ) {
-   flag -= ROAR_FLAG_MMAP;
-   return -1;
-  }
- }
-
- if ( flag & ROAR_FLAG_PRIMARY ) {
-  streams_set_primary(id, 0);
-  flag -= ROAR_FLAG_PRIMARY;
- }
-
- if ( flag & ROAR_FLAG_SINGLESINK ) {
-  if ( streams_set_single_sink(id, 1) == -1 ) {
-   return -1;
-  }
-  flag -= ROAR_FLAG_SINGLESINK;
- }
-
- if ( flag & ROAR_FLAG_SYNC ) {
-  // we refuse to reset the flag on FILTER streams
-  if ( streams_get_dir(id) == ROAR_DIR_FILTER ) {
-//   flags -= ROAR_FLAG_SYNC;
-   return -1;
-  } else {
-   if ( streams_set_sync(id, 0) == -1 )
-    return -1;
-
-   g_streams[id]->flags |= ROAR_FLAG_SYNC;
-   g_streams[id]->flags -= ROAR_FLAG_SYNC;
-   flag -= ROAR_FLAG_SYNC;
-   streams_change_sync_num(id, -1);
-  }
- }
-
- g_streams[id]->flags |= flag;
- g_streams[id]->flags -= flag;
-
- ROAR_DBG("streams_reset_flag(id=%i, flag=0x%.8X) = 0", id, flag);
-
- return 0;
-}
-
-int streams_get_flag     (int id, uint32_t flag) {
- _CHECK_SID(id);
-
- return g_streams[id]->flags & flag ? 1 : 0;
-}
-
-int streams_protect_flag (int id, uint32_t flag) {
- _CHECK_SID(id);
-
- g_streams[id]->flags_protection |= flag;
-
- return 0;
-}
-
-int streams_set_name     (int id, char * name) {
- char * str;
-
- _CHECK_SID(id);
-
- if ( (str = roar_mm_strdup(name)) == NULL )
-  return -1;
-
- if ( g_streams[id]->name != NULL )
-  roar_mm_free(g_streams[id]->name);
-
- g_streams[id]->name = str;
-
- return 0;
-}
-
-char * streams_get_name  (int id) {
- _CHECK_SID_RET(id, NULL);
-
- return g_streams[id]->name;
-}
-
-
-int streams_calc_delay    (int id) {
- struct roar_stream_server * ss;
- struct roar_stream        * s;
- register uint_least32_t d = 0;
- uint_least32_t t[1];
- uint64_t       tmp;
-
- _CHECK_SID(id);
-
- if ( (s = ROAR_STREAM(ss = g_streams[id])) == NULL )
-  return -1;
-
- // mixer store there value in ss->delay directly
- if ( s->dir == ROAR_DIR_MIXING )
-  return 0;
-
-#if 0
- // this only confuses the user...
- if ( ss->mixer_stream != id ) {
-  if ( streams_calc_delay(ss->mixer_stream) != -1 ) {
-   d += g_streams[ss->mixer_stream]->delay; // in case we can calc the delay
-                                            // the stream must exist, so no check here
-  }
- }
-#endif
-
- if ( ss->codecfilter != -1 ) {
-  if ( codecfilter_delay(ss->codecfilter_inst, ss->codecfilter, t) != -1 )
-   d += *t;
- }
-
- if ( ss->vio.ctl != NULL ) {
-  if ( roar_vio_ctl(&(ss->vio), ROAR_VIO_CTL_GET_DELAY, t) != -1 ) { // *t is in byte
-   ROAR_DBG("streams_calc_delay(id=%i): VIO delay in byte: %i", id, *t);
-   tmp = *t;
-   tmp *= 1000000; // musec per sec
-   tmp /= s->info.rate * s->info.channels * (s->info.bits/8);
-   ROAR_DBG("streams_calc_delay(id=%i): VIO delay in musec: %llu", id, tmp);
-
-   d += tmp;
-  }
- }
-
- ROAR_DBG("streams_calc_delay(id=%i): delay in musec: %i", id, d);
-
- ss->delay = d;
-
- return 0;
-}
-
-int streams_set_mixer    (int id) {
- struct roar_stream_server * ss;
- struct roar_stream_server * pmss;
- int i;
- int subsys;
- int tsubsys;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( streams_get_flag(id, ROAR_FLAG_PASSMIXER) == 1 ) {
-  if ( (subsys = streams_get_subsys(id)) == -1 )
-   return -1;
-
-  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-   if ( (pmss = g_streams[i]) != NULL ) {
-    if ( streams_get_flag(i, ROAR_FLAG_PASSMIXER) == 1 ) {
-     tsubsys = streams_get_subsys(i);
-     if ( tsubsys == subsys || tsubsys == ROAR_SUBSYS_NONE ) {
-      if ( &(pmss->mixer) != &(ss->mixer) ) {
-       if ( roar_conv_volume(&(pmss->mixer), &(ss->mixer),
-                             ROAR_STREAM(pmss)->info.channels, ROAR_STREAM(ss)->info.channels) == -1 ) {
-        ROAR_WARN("streams_set_mixer(id=%i): Can not convert mixer settings for stream %i", id, i);
-       }
-      }
-
-      // update hwmixers and the like but do not set mixer value recrusivly.
-      streams_reset_flag(i, ROAR_FLAG_PASSMIXER);
-      streams_set_mixer(i);
-      streams_set_flag(i, ROAR_FLAG_PASSMIXER);
-     }
-    }
-   }
-  }
- }
-
- roar_notify_core_emit_snoargs(ROAR_OE_STREAM_CHANGE_VOLUME, -1, id, ROAR_OT_STREAM);
-
- if ( !streams_get_flag(id, ROAR_FLAG_HWMIXER) )
-  return 0;
-
- if ( ss->driver_id != -1 ) {
-  return driver_set_volume(id, &(ss->mixer));
-#ifndef ROAR_WITHOUT_DCOMP_MIXER
- } else if ( ss->mixerstream != NULL ) {
-  return hwmixer_set_volume(id, ss, ss->mixerstream, &(ss->mixer));
-#endif
- } else {
-  return 0;
- }
-}
-
-int streams_set_map      (int id, char * map, size_t len) {
- struct roar_stream_server * ss;
- int ssdir;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( map != NULL ) {
-  if ( ROAR_STREAM(ss)->info.channels != len )
-   return -1;
- }
-
- ssdir = streams_get_ssdir(id);
-
- switch (ssdir) {
-  case STREAM_DIR_IN:
-  case STREAM_DIR_NONE:
-    memset(ss->chanmap.in, 0, sizeof(ss->chanmap.in));
-
-    if ( map != NULL )
-     memcpy(ss->chanmap.in, map, len);
-
-    roardsp_chanmap_calc(&(ss->chanmap), ROARDSP_CHANMAP_MAP, 0);
-   break;
-  case STREAM_DIR_OUT:
-    memset(ss->chanmap.out, 0, sizeof(ss->chanmap.out));
-
-    if ( map != NULL )
-     memcpy(ss->chanmap.out, map, len);
-
-    roardsp_chanmap_calc(&(ss->chanmap), ROARDSP_CHANMAP_MAP, 0);
-   break;
-  default:
-    return -1;
- }
-
- return 0;
-}
-
-int streams_get_rpg      (int id, struct roar_stream_rpg * rpg) {
- _CHECK_SID(id);
-
- if ( rpg == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- rpg->mode = g_streams[id]->rpgmode;
- rpg->mul  = g_streams[id]->mixer.rpg_mul;
- rpg->div  = g_streams[id]->mixer.rpg_div;
-
- if ( rpg->mode == ROAR_RPGMODE_DEFAULT )
-  rpg->mode = g_config->streams[ROAR_STREAM(g_streams[id])->dir].rpgmode;
-
- return 0;
-}
-
-int streams_set_rpg      (int id, const struct roar_stream_rpg * rpg) {
- int mode;
-
- _CHECK_SID(id);
-
- if ( rpg == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- // test if we have a valid value at all.
- if ( rpg->mode > ROAR_RPGMODE_TRACKALBUM || rpg->mode < ROAR_RPGMODE_DEFAULT ) {
-  roar_err_set(ROAR_ERROR_RANGE);
-  return -1;
- }
-
- mode = g_streams[id]->rpgmode = rpg->mode;
-
- if ( mode == ROAR_RPGMODE_DEFAULT )
-  mode = g_config->streams[ROAR_STREAM(g_streams[id])->dir].rpgmode;
-
- switch (mode) {
-  case ROAR_RPGMODE_NONE:
-    g_streams[id]->mixer.rpg_mul = 1;
-    g_streams[id]->mixer.rpg_div = 1;
-   break;
-  case ROAR_RPGMODE_USER:
-    g_streams[id]->mixer.rpg_mul = rpg->mul;
-    g_streams[id]->mixer.rpg_div = rpg->div;
-   break;
- }
-
- return 0;
-}
-
-
-int streams_ltm_ctl      (int id, int mt, int window, int cmd) {
- struct roar_stream_server * ss;
- struct roar_stream_ltm *    ltm;
- int i;
-
- _CHECK_SID(id);
-
- // currently we only support the WORKBLOCK window
- if ( window != ROAR_LTM_WIN_WORKBLOCK )
-  return -1;
-
- // currently we only support ROAR_LTM_MT_RMS
- if ( (mt | ROAR_LTM_MT_RMS) - ROAR_LTM_MT_RMS )
-  return -1;
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- switch (cmd) {
-  case ROAR_LTM_SST_NOOP:
-    return 0;
-   break;
-  case ROAR_LTM_SST_REGISTER:
-    // test if the window is already registered:
-    for (i = 0; i < MAX_LTM_WINDOWS_PER_STREAM; i++) {
-     ltm = &(ss->ltm[i]);
-     if ( ltm->refc && ltm->window == window ) {
-      ltm->refc++;
-      ltm->mt |= mt;
-      return 0;
-     }
-    }
-
-    // register
-    for (i = 0; i < MAX_LTM_WINDOWS_PER_STREAM; i++) {
-     ltm = &(ss->ltm[i]);
-     if ( ltm->refc == 0 ) {
-      memset(ltm, 0, sizeof(struct roar_stream_ltm));
-      ltm->refc = 1;
-      ltm->window = window;
-      ltm->parent_window = -1;
-      ltm->mt = mt;
-      ltm->channels = ROAR_STREAM(ss)->info.channels;
-      if ( (ltm->cur = roar_mm_malloc(ltm->channels*sizeof(struct roar_ltm_vals))) == NULL ) {
-       ltm->refc = 0; // reset
-       return -1;
-      }
-      memset(ltm->cur, 0, ltm->channels*sizeof(struct roar_ltm_vals));
-      return 0;
-     }
-    }
-    return -1;
-   break;
-  case ROAR_LTM_SST_UNREGISTER:
-    for (i = 0; i < MAX_LTM_WINDOWS_PER_STREAM; i++) {
-     ltm = &(ss->ltm[i]);
-     if ( ltm->refc && ltm->window == window ) {
-      ltm->refc--;
-      if ( ! ltm->refc ) {
-       roar_mm_free(ltm->cur);
-       return 0;
-      }
-     }
-    }
-    return -1;
-   break;
-  default:
-    return -1;
-   break;
- }
-}
-
-int streams_ltm_calc     (int id, struct roar_audio_info * info, void * data, size_t len) {
- struct roar_stream_server * ss;
- struct roar_stream_ltm *    ltm = NULL;
- int64_t rmsbuf_real[8];
- int64_t * rmsbuf = rmsbuf_real;
- size_t samples = 0;
- int i;
-
- _CHECK_SID(id);
-
- if ( data == NULL || info == NULL )
-  return -1;
-
- if ( info->codec != ROAR_CODEC_DEFAULT )
-  return -1;
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- for (i = 0; i < MAX_LTM_WINDOWS_PER_STREAM; i++) {
-  if ( ss->ltm[i].refc && ss->ltm[i].window == ROAR_LTM_WIN_WORKBLOCK ) {
-   ltm = &(ss->ltm[i]);
-   break;
-  }
- }
-
- if ( ltm == NULL )
-  return -1;
-
- // TODO: support change of number of channels
- if ( ltm->channels != info->channels )
-  return -1;
-
- if ( len == 0 ) {
-  memset(ltm->cur, 0, ltm->channels * sizeof(struct roar_ltm_vals));
-  return 0;
- }
-
- // TODO: support more channels then rmsbuf_real has space for
- if ( ltm->channels > (sizeof(rmsbuf_real)/sizeof(*rmsbuf_real)) ) {
-  return -1;
- }
-
- samples = len / info->bits;
-
- if ( ltm->mt & ROAR_LTM_MT_RMS ) {
-  if ( roar_rms2_1_b_n(data, samples, rmsbuf, ltm->channels, info->bits) == -1 )
-   return -1;
-
-  for (i = 0; i < ltm->channels; i++) {
-   ltm->cur[i].rms = rmsbuf[i] << (64 - info->bits*2);
-  }
-
-  ROAR_DBG("streams_ltm_calc(id=%i,...): rmsbuf[0]=%lli", id, (long long int)rmsbuf[0]);
- }
-
- return 0;
-}
-
-struct roar_stream_ltm * streams_ltm_get(int id, int mt, int window) {
- struct roar_stream_server * ss;
- struct roar_stream_ltm *    ltm = NULL;
- int i;
-
- _CHECK_SID_RET(id, NULL);
-
- if ( (ss = g_streams[id]) == NULL )
-  return NULL;
-
- for (i = 0; i < MAX_LTM_WINDOWS_PER_STREAM; i++) {
-  if ( ss->ltm[i].refc && ss->ltm[i].window == window ) {
-   ltm = &(ss->ltm[i]);
-   break;
-  }
- }
-
- if ( ltm == NULL )
-  return NULL;
-
- if ( (ltm->mt & mt) != mt )
-  return NULL;
-
- return ltm;
-}
-
-#ifndef ROAR_WITHOUT_DCOMP_MIXER
-struct hwmixer_stream * streams_get_mixerstream(int id) {
- _CHECK_SID_RET(id, NULL);
-
- return g_streams[id]->mixerstream;
-}
-
-int streams_set_mixerstream(int id, struct hwmixer_stream * mstream) {
- _CHECK_SID(id);
-
- g_streams[id]->mixerstream = mstream;
-
- return 0;
-}
-
-int streams_read_mixervalues(int id) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( ss->mixerstream == NULL )
-  return -1;
-
- return hwmixer_get_volume(id, ss, ss->mixerstream, &(ss->mixer));
-}
-#endif
-
-int streams_ctl          (int id, int_least32_t cmd, void * data) {
- struct roar_stream_server * ss;
- int_least32_t comp;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- comp = cmd & ROAR_STREAM_CTL_COMPMASK;
-
- cmd &= ~comp;
-
- ROAR_DBG("streams_ctl(id=%i, cmd=?, data=%p): comp=0x%.8x, cmd=0x%.4x", id, data, comp, cmd);
-
- switch (comp) {
-  case ROAR_STREAM_CTL_COMP_BASE:
-   break;
-  case ROAR_STREAM_CTL_COMP_CF:
-    return codecfilter_ctl(ss->codecfilter_inst, ss->codecfilter, cmd, data);
-   break;
-  case ROAR_STREAM_CTL_COMP_DRV:
-   break;
-  default:
-   return -1;
- }
-
- return -1;
-}
 
 int streams_get_outputbuffer  (int id, void ** buffer, size_t size) {
- _CHECK_SID(id);
+ if ( g_streams[id] == NULL )
+  return -1;
 
  // output buffer size does never change.
@@ -1806,5 +131,5 @@
  }
 
- if ( (g_streams[id]->output = roar_mm_malloc(size)) == NULL ) {
+ if ( (g_streams[id]->output = malloc(size)) == NULL ) {
   ROAR_ERR("streams_get_outputbuffer(*): Can not alloc: %s", strerror(errno));
   return -1;
@@ -1816,152 +141,198 @@
 }
 
-int streams_fill_mixbuffer2 (int id, struct roar_audio_info * info) {
- size_t   outlen = ROAR_OUTPUT_CALC_OUTBUFSIZE(info);
- void   * outdata;
- size_t   inlen;
- size_t   inlen_got;
- void   * indata = NULL;
- size_t   buflen;
- void   * bufdata = NULL;
- struct roar_buffer * bufbuf = NULL;
- int      is_the_same = 0;
- struct roar_audio_info    * stream_info;
- struct roar_stream        * s;
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (s = ROAR_STREAM(ss = g_streams[id])) == NULL )
-  return -1;
+int streams_fill_mixbuffer (int id, struct roar_audio_info * info) {
+ // TODO: decide: is this the most complex, hacked, un-understadable,
+ //               un-writeable and even worse: un-readable
+ //               function in the whole project?
+ size_t todo = ROAR_OUTPUT_CALC_OUTBUFSIZE(info);
+ size_t todo_in;
+ size_t len, outlen;
+ size_t mul = 1, div = 1;
+ void * rest = NULL;
+ void * in   = NULL;
+ struct roar_buffer     * buf;
+ struct roar_audio_info * stream_info;
+ int is_the_same = 0;
+
+ if ( g_streams[id] == NULL )
+  return -1;
+
+ if ( streams_get_outputbuffer(id, &rest, todo) == -1 ) {
+  return -1;
+ }
+
+ if ( rest == NULL ) {
+  return -1;
+ }
 
  // set up stream_info
- stream_info = &(s->info);
+
+ stream_info = &(((struct roar_stream*)g_streams[id])->info);
 
  // calc todo_in
- inlen = ROAR_OUTPUT_CALC_OUTBUFSIZE(stream_info);
-
- buflen = ROAR_OUTPUT_CALC_OUTBUFSIZE_MAX(info, stream_info);
-
- ROAR_DBG("streams_fill_mixbuffer2(id=%i, info=%p{...}): inlen=%lu, buflen=%lu", id, info, (unsigned long)inlen, (unsigned long)buflen);
-
- if ( inlen == 0 ) {
-  ROAR_WARN("streams_fill_mixbuffer2(id=%i, info=%p{...}): inlen == 0, this should not happen!", id, info);
-  return -1;
- }
-
- if ( streams_get_outputbuffer(id, &outdata, outlen) == -1 ) {
-  return -1;
- }
-
- if ( outdata == NULL ) {
-  return -1;
- }
-
- ROAR_DBG("streams_fill_mixbuffer2(*): outdata=%p, len=%i->%i (in->out)", outdata, inlen, outlen);
+ todo_in = ROAR_OUTPUT_CALC_OUTBUFSIZE(stream_info);
+
+ // calc mul and div:
+ mul = todo    / todo_in;
+ div = todo_in / todo;
+
+ if ( mul == 0 ) {
+  mul = 1;
+ } else {
+  div = 1;
+ }
+
+ ROAR_DBG("streams_fill_mixbuffer(*): mul=%i, div=%i", mul, div);
+
+ ROAR_DBG("streams_fill_mixbuffer(*): rest=%p, todo=%i->%i (in->out)", rest, todo_in, todo);
+ // are both (input and output) of same format?
+
+
+ ROAR_DBG("streams_fill_mixbuffer(*): stream_info:");
+ roar_debug_audio_info_print(stream_info);
+ ROAR_DBG("streams_fill_mixbuffer(*): info:");
+ roar_debug_audio_info_print(info);
 
  is_the_same = stream_info->rate     == info->rate     && stream_info->bits  == info->bits &&
                stream_info->channels == info->channels && stream_info->codec == info->codec;
 
- ROAR_DBG("streams_fill_mixbuffer2(*): is_the_same=%i", is_the_same);
-
- if ( !is_the_same && buflen > outlen ) {
+ ROAR_DBG("streams_fill_mixbuffer(*): is_the_same=%i", is_the_same);
+
+/* How it works:
+ *
+ * set a counter to the number of samples we need.
+ * loop until we have all samples done or no samples are
+ * left in our input buffer.
+ * If there a no samples left in the input buffer: fill the rest
+ * of the output buffer with zeros.
+ *
+ * The loop:
+ * get a buffer from the input.
+ * if it's bigger than needed, set an offset.
+ * The rest of the data:
+ * 0) convert endianness (codec) from remote to local...
+ * 1) change bits in of the samples
+ * 2) change sample rate
+ * 3) change the nummber of channels
+ * 4) insert into output buffer
+ */
+
 /*
-  // this is not supported at the moment
-  memset(outdata, 0, outlen);
-  return -1;
+ // get our first buffer:
+
+ if ( stream_shift_buffer(id, &buf) == -1 ) {
+  return -1;
+ }
+
+ // first test for some basic simple cases...
+
+ if ( buf == NULL ) { // we habe nothing in input queue
+                      // we may memset() our output buffer OR
+                      // just return with -1 so we are going to
+                      // be ignored.
+  return -1;
+ }
 */
 
-  if ( roar_buffer_new(&bufbuf, buflen) == -1 )
-   return -1;
-
-  if ( roar_buffer_get_data(bufbuf, &bufdata) == -1 )
-   return -1;
-  indata  = bufdata;
- } else {
-  indata  = outdata;
-  bufdata = outdata;
- }
-
- inlen_got = inlen;
-
- ROAR_DBG("streams_fill_mixbuffer2(id=%i, info=...): inlen_got=%u", id, inlen_got);
-
- if ( stream_shift_out_buffer(id, indata, &inlen_got) == -1 ) {
-  if ( ss->is_new ) {
-   ss->pre_underruns++;
-   roar_notify_core_emit_simple(ROAR_OE_STREAM_XRUN, -1, id, ROAR_OT_STREAM, ROAR_XRUN_UNDER_PRE, ss->pre_underruns, NULL, 0);
+ while (todo) { // main loop
+  ROAR_DBG("streams_fill_mixbuffer(*): looping...");
+  // exit loop if nothing is left, even if we need more data..
+  if ( stream_shift_buffer(id, &buf) == -1 )
+   break;
+  if ( buf == NULL )
+   break;
+
+  // read the data for this loop...
+  roar_buffer_get_data(buf, &in);
+  roar_buffer_get_len(buf, &len);
+
+  ROAR_DBG("streams_fill_mixbuffer(*): len = %i", len);
+
+  if ( len > todo_in ) {
+   roar_buffer_set_offset(buf, todo_in);
+   len = todo_in;
   } else {
-   ROAR_WARN("streams_fill_mixbuffer2(id=%i, info=...): underrun in stream", id);
-   ss->post_underruns++;
-   roar_notify_core_emit_simple(ROAR_OE_STREAM_XRUN, -1, id, ROAR_OT_STREAM, ROAR_XRUN_UNDER_POST, ss->post_underruns, NULL, 0);
+   roar_buffer_set_len(buf, 0); // queue for deletation
   }
-  memset(outdata, 0, outlen);
-  return 0;
- }
-
- ROAR_DBG("streams_fill_mixbuffer2(id=%i, info=...): inlen_got=%u", id, inlen_got);
-
- if ( ss->is_new ) {
-  //ROAR_INFO("streams_fill_mixbuffer2(id=%i, info=...): stream state: new->old", ROAR_DBG_INFO_VERBOSE, id);
-  _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_fill_mixbuffer2");
- }
-
- ss->is_new = 0;
-
- // check channel map:
-#if 0
- if ( roardsp_chanmap_mappcm(indata, indata, inlen, stream_info->channels, &(ss->chanmap), stream_info->bits) == -1 ) {
-  if ( bufbuf != NULL )
-   roar_buffer_free(bufbuf);
-  return -1;
- }
-#endif
-
- // TODO: this only works in case a we have a amp for the given stream parameters.
- if ( !streams_get_flag(id, ROAR_FLAG_HWMIXER) && !streams_get_flag(id, ROAR_FLAG_PASSMIXER) ) {
-  ROAR_DBG("streams_fill_mixbuffer2(*): CALL roar_amp_pcm(*)...");
-  if ( roar_amp_pcm(indata, stream_info->bits, indata, 8*inlen / stream_info->bits, stream_info->channels, &(ss->mixer)) == -1 )
-   return -1;
- }
-
- // check codec, bits, channels, rate...
- if ( is_the_same ) {
-  if ( indata != outdata )
-   memcpy(outdata, indata, inlen);
-
-  if ( inlen < outlen )
-   memset(outdata+inlen, 0, outlen-inlen);
- } else {
-//  if ( roar_conv(outdata, indata, (8*inlen_got*info->rate)/(stream_info->rate * stream_info->bits), stream_info, info) == -1 ) {
-  ROAR_DBG("streams_fill_mixbuffer2(*): CALL roar_conv2(*)...");
-  if ( roar_conv2(bufdata, indata, inlen, stream_info, info, outlen) == -1 ) {
-   if ( bufbuf != NULL )
-    roar_buffer_free(bufbuf);
+
+  // we now have 'len' bytes in 'in'
+
+  // calc how much outlen this has...
+  outlen = (len * mul) / div;
+
+  ROAR_DBG("streams_fill_mixbuffer(*): outlen = %i, buf = %p, len = %i", outlen, in, len);
+
+  if ( is_the_same ) {
+/*
+ * 0) convert endianness (codec) from remote to local...
+ * 1) change bits in of the samples
+ * 2) change sample rate
+ * 3) change the nummber of channels
+   \\==> skiping,...
+ */
+   // * 4) insert into output buffer
+   ROAR_DBG("streams_fill_mixbuffer(*): memcpy: in->rest: %p -> %p", in, rest);
+   if ( memcpy(rest, in, len) != rest ) {
+    ROAR_ERR("streams_fill_mixbuffer(*): memcpy returned invalid pointer.");
+   }
+
+  } else {
+
+/*
+   // * 0) convert endianness (codec) from remote to local...
+   if ( stream_info->codec != info->codec ) {
+    // we neet to convert...
+    return -1;
+   }
+
+   // * 1) change bits in of the samples
+   if ( stream_info->bits != info->bits ) {
+    return -1;
+   }
+
+   // * 2) change sample rate
+   if ( stream_info->rate != info->rate ) {
+    return -1;
+   }
+
+   // * 3) change the nummber of channels
+   if ( stream_info->channels != info->channels ) {
+    return -1;
+   }
+
+   // * 4) insert into output buffer
+*/
+  // hey! we have roar_conv() :)
+
+  if ( roar_conv(rest, in, 8*len / stream_info->bits, stream_info, info) == -1 )
    return -1;
   }
 
-//  memset(outdata, 0, outlen);
- }
-
- if ( bufbuf != NULL ) {
-  memcpy(outdata, bufdata, outlen);
-  roar_buffer_free(bufbuf);
- }
-
- streams_ltm_calc(id, stream_info, outdata, outlen);
-
- if ( streams_get_flag(id, ROAR_FLAG_ANTIECHO) ) {
-  ROAR_DBG("streams_fill_mixbuffer2(*): Calcing antiecho...");
-  // we can ignore errors here:
-  if ( stream_outputbuffer_request(id, &bufbuf, buflen) == 0 ) {
-   if ( roar_buffer_get_data(bufbuf, &bufdata) != -1 )
-    memcpy(bufdata, outdata, outlen);
-  }
- }
-
- ROAR_DBG("streams_fill_mixbuffer2(*): inlen_got=%llu, stream_info={.bits=%i, .rate=%i,...}", (long long unsigned int)inlen_got, stream_info->bits, stream_info->rate);
- s->pos = ROAR_MATH_OVERFLOW_ADD(s->pos, (inlen_got*8)/stream_info->bits);
-
- ROAR_DBG("streams_fill_mixbuffer2(*) = 0");
+  // we habe outlen bytes more...
+  todo    -= outlen;
+  rest    += outlen;
+  todo_in -= len;
+
+  roar_buffer_get_len(buf, &len);
+  ROAR_DBG("streams_fill_mixbuffer(*): New length of buffer %p is %i", buf, len);
+  if ( len == 0 )
+   roar_buffer_delete(buf, NULL);
+ }
+
+ //len = 0;
+ //buffer_get_len(buf, &len);
+
+/*
+ if ( len > 0 ) // we still have some data in this buffer, re-inserting it to the input buffers...
+  stream_unshift_buffer(id, buf);
+ else
+  buffer_delete(buf, NULL);
+*/
+
+ if ( todo > 0 ) { // zeroize the rest of teh buffer
+  memset(rest, 0, todo);
+  ROAR_ERR("streams_fill_mixbuffer(*): Underrun in stream: %i bytes missing, filling with zeros", todo);
+ }
+
  return 0;
 }
@@ -1969,27 +340,11 @@
 
 int streams_get_mixbuffers (void *** bufferlist, struct roar_audio_info * info, unsigned int pos) {
- static void * bufs[ROAR_STREAMS_MAX+1];
+ static void * bufs[ROAR_STREAMS_MAX];
  int i;
  int have = 0;
- int dir;
 
  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
   if ( g_streams[i] != NULL ) {
-   dir = streams_get_dir(i);
-
-   switch (dir) {
-    case ROAR_DIR_PLAY:
-    case ROAR_DIR_BIDIR:
-    case ROAR_DIR_RECPLAY:
-     break;
-    case ROAR_DIR_BRIDGE:
-      if ( g_streams[i]->buffer == NULL )
-       continue;
-     break;
-    default:
-      continue;
-   }
-
-   if ( streams_get_flag(i, ROAR_FLAG_PAUSE) )
+   if ( ((struct roar_stream *)g_streams[i])->dir != ROAR_DIR_PLAY )
     continue;
 
